local input_stack = {}
local input_stack_size = 0

local msgpost = msg.post

msg.post = function(receiver, message_id, message)
	if message_id == "acquire_input_focus" or message_id == hash("acquire_input_focus") then
		input_stack_size = input_stack_size + 1
		input_stack[tostring(msg.url())] = input_stack_size
		print("Register #"..input_stack_size.." is "..msg.url())
	end
	msgpost(receiver, message_id, message or {})
end

local collection_of_inputs = {}

local function printer(v)
	print("Input in "..tostring(v).." registered #"..tostring(input_stack[tostring(v)]))
end

return {
	collector = function(self, action_id, action)
		if action_id == hash("print_once") and action.released then
			collection_of_inputs[#collection_of_inputs + 1] = msg.url()
			timer.delay(0.1, false, function()
				for i, v in ipairs(collection_of_inputs) do
					printer(v)
				end
				collection_of_inputs = {}
			end)
		end
	end
}